Unit ASH0C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASH0C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; var S :Array of Real;
                N :Integer; P :Integer);

implementation

procedure ASH0C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; var S :Array of Real;
                N :Integer; P :Integer);
var
J,J1,I,I1,K,N1 :Integer;
V :Real;
Z :Complex;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
if ( P <> 1 ) 
 then goto _7;
S[0] := Creal(DivC(Cmplx(1.0,0.0),A[0+0*N]));
J := 2;
J1 := 1;
goto _4;
_1:
J1 := J;
J := J+1;
for I:=2 to J1 do
 begin
  I1 := I-1;
  Z := A[(I-1)+(J-1)*N];
  for K:=1 to I1 do
   begin
_2:
    Z := SubC(Z,MulC(A[(K-1)+(J-1)*N],Conjg(A[(K-1)+(I-1)*N])));
   end;
_3:
  A[(I-1)+(J-1)*N] := Z;
 end;
_4:
V := Creal(A[(J-1)+(J-1)*N]);
for K:=1 to J1 do
 begin
  Z := A[(K-1)+(J-1)*N];
_5:
  V := Creal(SubC(Cmplx(V,0.0),MulC(MulC(Z,Conjg(Z)),Cmplx(S[K-1],0.0))));
 end;
S[J-1] := 1.0/V;
for I:=1 to J1 do
 begin
_6:
  A[(I-1)+(J-1)*N] := MulC(A[(I-1)+(J-1)*N],Cmplx(S[I-1],0.0));
 end;
if ( J <> N ) 
 then goto _1;
_7:
X[0] := B[0];
for I:=2 to N do
 begin
  Z := B[I-1];
  I1 := I-1;
  for K:=1 to I1 do
   begin
_8:
    Z := SubC(Z,MulC(Conjg(A[(K-1)+(I-1)*N]),X[K-1]));
   end;
_9:
  X[I-1] := Z;
 end;
N1 := N+1;
for J:=1 to N do
 begin
  I := N1-J;
  Z := MulC(X[I-1],Cmplx(S[I-1],0.0));
  I1 := I+1;
  for K:=I1 to N do
   begin
_10:
    Z := SubC(Z,MulC(A[(I-1)+(K-1)*N],X[K-1]));
   end;
_11:
  X[I-1] := Z;
 end;
end;

end.
